import sys, socket, math, traceback
from zival import *

class Socket:
	__slots__ = ["sock", "buf"]
	
	def __init__(self): self.sock = None; self.buf = ""
	def connect(self, hostName, port):
		try:
			self.sock = socket.socket(socket.AF_INET)
			self.sock.connect((hostName, port))
		except: raise Exception("Prijava na streznik neuspesna")
		self.buf = ""
		#
		server = sock.readline()
		print "%s" % server
		sock.writeline("AVE %s %s" % ({pasmaMuca: "MACKA", pasmaMis: "MIS"}[Zival.tip], Zival.ime))
		succ = sock.readline()
		if succ != "PRIJAVA USPESNA": raise Exception("Prijava na streznik neuspesna: %s" % succ)
	def close(self):
		if self.sock: self.sock.close()
	def readline(self):
		while True:
			i = self.buf.find('\n')
			if i >= 0: 
				line = self.buf[:i].strip()
				self.buf = self.buf[i + 1:]
				return line
			try: s = self.sock.recv(128)
			except: raise Exception("Napaka pri komunikaciji s streznikom")
			if not s: raise Exception("Streznik je zaprl povezavo")
			self.buf += s
	def writeline(self, line): self.sock.send(line + "\n")
	def event_loop(self):
		cmda = self.readline().split()
		if cmda[0] == "ADIJO": return False
		if cmda[0] == "KONEC_IGRE": return True
		if cmda[0] != "ZBUDI_SE": raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		
		j = Koordinate(float(cmda[1]), float(cmda[2]))
		n = Koordinate(float(cmda[3]), float(cmda[4]))
		z = Zival()
		ZeljenaSmer = z.ZbudiSe(j, n)
		self.writeline("BUDNA %f" % ZeljenaSmer)
		
		while True:
			cmda = self.readline().split()
			if cmda[0] == "ADIJO": return False
			elif cmda[0] == "KONEC_IGRE":
				z.KonecIgre(int(cmda[1])); break
			elif cmda[0] == "QV":
				sj = Stanje(*map(float, cmda[1:5]))
				sn = Stanje(*map(float, cmda[5:9]))
				(SpremembaSmeri, SpremembaHitrosti) = z.KamGres(sj, sn)
				self.writeline("QVR %f %f" % (SpremembaSmeri, SpremembaHitrosti))
			else: raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		return True

if len(sys.argv) > 1: hostName = sys.argv[1]
else: hostName = "localhost"

try:
	sock = Socket()
	sock.connect(hostName, 1174)
	while sock.event_loop(): pass
	sock.close()
except:
	traceback.print_exc()
